   '         Orb of my Life
   '
   '          by John Nelson
   '
   '
    KEY OFF
REM $$INCL:'\EAMON\COPY\COLORRTN.BAS'
     ON ERROR GOTO NoColors
     OPEN "EAMCOLOR" FOR INPUT AS #1
     INPUT #1, fgc%
     INPUT #1, bgc%
     INPUT #1, hfg%
     INPUT #1, hbg%
     CLOSE
In.BW:
     ON ERROR GOTO 0
     COLOR fgc%, bgc%
     GOTO Colorset
NoColors:
      fgc% = 7
      bgc% = 0
      hfg% = 0
      hbg% = 7
      RESUME In.BW
Colorset:

    '------- (end of include file) -------    
 ' 
    GOSUB HEADRTN
    PRINT "Scarcely in recorded history has Eamon experienced such calamity. It seems all    "
    PRINT "of nature has finally run amok. Animals normally possessed of mild temprement,     "
    PRINT "attack on sight and fight to the death. Strange winds and storms come up without   "
    PRINT "foresight or warning, and then just as quickly are gone. No one, so far seems     "
    PRINT "to have an answer.                         "
    PRINT
    PRINT "You are at a loss at what to do, if anything, when you are summoned to the        "
    PRINT "royal palace. Sagonne, royal wizard to the king has sent for all experienced      "
    PRINT "free-adventurers to come to his aid. The palace guard reports that you are the      "
    PRINT "only one they could find. All the others have run off in search of the solution     "
    PRINT "to this crisis on their own, or are hiding out until it passes.                "
    PRINT : GOSUB page.break
    PRINT "Sagonne greets you from his bed, the life force seems to be draining from him       "
    PRINT "each passing minute. He explains: 'I need your help. I was going to use the         "
    PRINT "power of my own life orb to battle the strange forces that are tearing at           "
    PRINT "Eamon, but upon reaching it's magical resting place, I discovered it missing.       "
    PRINT "I suspect there may be a link between its disappearance and this crisis.            "
    PRINT :
    RANDOMIZE TIMER
    PRINT "During the last few nights, I have had nightmares about someone trying to take      "
    PRINT "the orb away. I woke each night with a hideous scream in a cold sweat. I took       "
    PRINT "the precaution of placing a powerful forcefield around the orb. Apparently          "
    PRINT "it wasn't powerful enough.                 "
    PRINT :
    GOSUB page.break
    PRINT "The orb is a magic vessel of great power and value - a powerful magic amplifier.    "
    PRINT "It can increase the amount of magic a being can generate. If the possessor is       "
    PRINT "willing to make the sacrifice of linking his life force to that of the orb, the     "
    PRINT "level of power that can be achieved is triple what would normally be possible.    "
    PRINT
    PRINT "I made that sacrifice. but now that the orb is missing, my life force has almost    "
    PRINT "gone with it. I must have the orb back before my life force ebbs and I die.'        "
    PRINT : GOSUB page.break
    PRINT "Recently I sent a party of adventurer's to the lair of Tolor, a good friend of      "
    PRINT "mine to seek his aid, but there was a cave-in. Some of the party were trapped       "
    PRINT "and buried, others returned, saying the entrance was forever blocked.               "
    PRINT
    PRINT "Tolor seems to have what we need to get where we must go, but he is forever         "
    PRINT "buried now, possibly dead. There is only one hope - a rumored alternate route. I    "
    PRINT "have instructed the palace guard to take you to a temple. There you may find the    "
    PRINT "way. And please -- be thou careful with the orb - for it is the orb of my life!'    "
    PRINT "With that, Sagonne passes out.             "
    GOSUB page.break
    GOSUB do.magic
    RUN "MAINPGM"
page.break:  ' --------- page break ------------
    LOCATE 24, 1
    PRINT "==================== Press Any Key to Continue ====================";
    A$ = ""
    WHILE A$ = ""
    A$ = INKEY$
    WEND
HEADRTN:
    CLS
    COLOR hfg%, hbg%
    PRINT SPACE$(32); "Orb of My Life"; SPACE$(32)
    COLOR fgc%, bgc%
    PRINT
    RETURN
do.magic:  ' generate magic phrases
    READ mw: DIM mw$(mw): FOR x = 1 TO mw: READ mw$(x): NEXT
    READ tw: DIM tw$(tw): FOR x = 1 TO tw: READ tw$(x): NEXT
    READ cw: DIM cw$(cw): FOR x = 1 TO cw: READ cw$(x): NEXT
    m = INT(RND(1) * mw + 1): mw$ = mw$(m)
    t = INT(RND(1) * tw + 1): tw$ = tw$(t)
    c = INT(RND(1) * cw + 1): cw$ = cw$(c)
    OPEN "MAGIC.TXT" FOR OUTPUT AS #1
    WRITE #1, mw$
    WRITE #1, tw$
    WRITE #1, cw$
    CLOSE
    RETURN
    DATA 5
    DATA Evantke,Zabata,Vorika,Haxam,Farzak
    DATA 4
    DATA Voraka Mede,Hoboro Wan,Vesheba Kala,Shamasa Vorik
    DATA 4
    DATA Shumat Codo,Horazik Vin,Erada Vala,Goribi Pane

