' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank Black                        
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'                    UTILITY MENU PROGRAM                        
'                                                                
'                                           Update: 21 OCT 2000  
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
ON ERROR GOTO ErHndlr

OPEN "SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, CC1#, CC2#, CC3#: CLOSE
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)

Menu:
CLS : COLOR 3: PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(20); "EAMON DELUXE v3.1 UTILITIES MENU";
PRINT SPACE$(22); CHR$(179): PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
PRINT : PRINT

c = 0: c1 = 5
CALL EDXMenuM(c, c1, 1, 12, 2, 0)

IF c1 = 3 THEN c = 8
IF c = 1 OR c = 2 THEN RUN "DUMMY" 'RUN "TOOLS"
IF c = 3 THEN RUN "RESET"
IF c = 4 THEN RUN "PLRWIPE"
IF c = 5 THEN RUN "DUMMY" 'RUN "MAKESHPS"
IF c = 6 THEN RUN "TXTMV"
IF c = 7 THEN RUN "DUMMY" 'RUN "CONVERT6"
IF c = 8 THEN RUN "DUMMY" 'RUN "CONVERT7"
IF c = 9 THEN RUN "DUMMY" 'RUN "HINTMAKE"
IF c = 10 THEN RUN "SHIFT"
IF c = 12 THEN CHDIR "..": RUN "EAMONDX"

CLS : COLOR 2: PRINT "NOTES AND WARNING --": COLOR 3: PRINT
PRINT "This collection of utility programs is designed for advanced users and dungeon"
PRINT "designers.  Instructions for most of the programs are located in the comments at"
PRINT "the beginning of that particular program and will not be repeated here."
PRINT : COLOR 14
PRINT "If you don't know what you're doing or what a program does, don't use it!"
PRINT : COLOR 3
PRINT "The following files are also in this directory (C:\EAMONDX\UTILS), but are not"
PRINT "available through the menu for various reasons:"
PRINT : GOSUB GetKey0: CLS
PRINT "CONV.BAS": PRINT
PRINT "This a modified version of CONVERT6.BAS which was made for v.4-5 adventures that"
PRINT "had their 'dead body' artifacts at the beginning of the database instead of the"
PRINT "end.  It assumes that the dead bodies have been removed and subtracts them from"
PRINT "monster weapon values.  Note that it doesn't change anything else."
PRINT : COLOR 2
PRINT "This program must be copied to your adventure directory before use!"
PRINT : COLOR 3: GOSUB GetKey0: CLS
PRINT "INTRO-M.BAS  and  MP6.BAS": PRINT
PRINT "INTRO-M is (you guessed it) the standard multi-adventure intro program that I"
PRINT "used for all the adventure collections.  It is set up for 'Classic Eamon' and"
PRINT "includes the adventure reviews option and such."
PRINT
PRINT "MP6 is a slightly modified version of the standard MAINPGM.BAS which reflects"
PRINT "version 4-6 Classic Eamons more in a few subtle ways.  See the comments at the"
PRINT "beginning of the MP6.BAS program for more details.  Can be substitued for"
PRINT "MAINPGM.BAS if you prefer."
PRINT : GOSUB GetKey0: CLS
PRINT "LIB1.BAS, LIB2.BAS, etc.": PRINT
PRINT "These are some of the standard Eamon Deluxe SUB programs (such as the menu in"
PRINT "this program.  They can be copied into your programs for your own use.  Each"
PRINT "LIB file has a short demonstration which shows you how to call the SUB.  The"
PRINT "SUBs have detailed comments within them."
GOSUB GetKey0: GOTO Menu

' Get a keypress
GetKey0:
PRINT : PRINT "Hit any key to continue...";
GetKey:
BS = POS(0): CC = 0
DO
   a = RND: CC = CC + 1
   IF CC = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC = 0
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""
PRINT k$: RETURN

'Ŀ
'                    Error handling routine                     
'
ErHndlr:
CLS : BEEP: PRINT "Run-time error"; ERR; "   ";
IF ERR = 53 THEN PRINT "(File not found)";
PRINT : PRINT : PRINT "Program terminated.": RESUME ErHndlr1
ErHndlr1:
ON ERROR GOTO 0: a$ = INKEY$: PRINT : PRINT "(Hit any key)"
DO
LOOP UNTIL INKEY$ <> ""
SYSTEM

EDXMenuStrings:
DATA 12
DATA "  1. Create/Separate a multi-adventure. "
DATA "  2. Change the name of an adventure. "
DATA "  3. Reset default system settings. "
DATA "  4. Build a new 'PLAYERS' file from an old one. "
DATA "  5. View/store Graphic Main Hall tile sets. "
DATA "  6. Transfer adventure text to/from TXT file. "
DATA "  7. Convert v4-6 Apple Eamon data from TXT file to Eamon Deluxe "
DATA "  8. Convert  v7+ Apple Eamon data from TXT file to Eamon Deluxe "
DATA "  9. Append hints from a TXT file to an adventure. "
DATA " 10. Shift a TXT file to all lower-case. "
DATA " 11. Notes.  (READ ME BEFORE USING THESE UTILITIES!) "
DATA " 12. Exit utilities menu. "

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

