' THE WONDERFUL WORLD OF EAMON DELUXE v4.5 ͻ
'                       by Frank Black                           
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'    STARTUP PROGRAM                Revision: 14 MAR 2005        
'                                     Update: 05 APR 2012        
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Set.Speed ()
DECLARE SUB EDX.Set.Screen ()
DECLARE SUB EDX.Save.Settings ()
DECLARE SUB Header (h$)
DECLARE SUB View.Manuals ()
DECLARE SUB EDX.Main.Menu (c)
DECLARE SUB Remove.Adventure ()
DECLARE SUB Control.Panel ()
DECLARE SUB Continue.Saved.Game ()
DECLARE SUB EDX.Select.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB GetKey (k, a$)

TYPE adv
   ANAME AS STRING * 78: NUMBER AS INTEGER
END TYPE
DIM SHARED adv AS adv

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10), ProgErr

'    Reset Windows' annoying cursor delay
SHELL "MODE CON RATE=30 DELAY=1"

'    Reset Windows' annoying little box window
'SCREEN 7: SCREEN 0: WIDTH 80: CLS
SCREEN 0: WIDTH 80: CLS
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

'   Initialize choices and exit codes for EDXMenu and EDXMenuM
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0 + 5)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)

'         Auto-speed and screen sets
IF dly# = 0 THEN CALL EDX.Set.Speed: CALL EDX.Save.Settings
IF s%(1) = -1 THEN CALL EDX.Set.Screen: CALL EDX.Save.Settings

CALL EDX.Main.Menu(c)
IF c = 1 THEN CHDIR "MAIN": RUN "EDXDEMO"
IF c = 2 THEN CALL Continue.Saved.Game: RUN
IF c = 3 THEN CHDIR "MAIN": RUN "CHAREDIT"
IF c = 4 THEN CHDIR "DD": RUN "DDMENU"
IF c = 5 THEN CALL Remove.Adventure: RUN
IF c = 6 THEN CALL View.Manuals: RUN
IF c = 7 THEN CALL Control.Panel: RUN
IF c = 8 THEN CHDIR "UTILS": RUN "UMENU"
IF c = 9 THEN RUN "EDXEXIT"

FileIOError:
ProgErr = ERR: RESUME NEXT

EDXMenuStrings:
DATA 35
DATA 1.  Eamon Deluxe Players Manual
DATA 2.  Eamon Deluxe Dungeon Designer's Manual
DATA 3.  Adventure lists
DATA 4.  Quit
DATA 1.  View on text screen
DATA 2.  Send to printer (LPT1)
DATA EAMONDX.TXT,DESIGN.TXT,ADVLISTS.TXT
DATA 1.  CGA               (The worst)
DATA "2.  EGA/VGA  320x200  (Nice picture, full color -RECOMMENDED!)"
DATA "3.  EGA/VGA  640x350  (Looks great, but kind of small)"
DATA reserved,reserved,reserved
DATA Blue,Green,Cyan,Red,Magenta,Brown,White,Gray,Light Blue,Light green
DATA Light cyan,Light red,Light magenta,Yellow,Bright white
DATA 1.  Change graphics mode.
DATA 2.  Toggle graphic/text Main Hall.
DATA 3.  Change Main Hall text color.
DATA 4.  Reset system speed.
DATA 5.  Exit.

SUB Continue.Saved.Game

' Attempt to continue a saved game
'
c = 2: CALL EDX.Select.Adventure(c, a$)
IF c = 0 OR c = -3 THEN EXIT SUB

'  Check adv. directory for saved games, then run leadin prog.
CHDIR a$: OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
IF a <> -1 THEN RUN "INTRO"

'  No saved game
CHDIR "..": PRINT "There are no saved games for that adventure!": PRINT
CALL GetKey(1, "")

EXIT SUB

END SUB

SUB Control.Panel
'
' Change System settings
'
ControlPanel:
IF s%(3) = 0 THEN s%(3) = 7
CLS : COLOR 3: PRINT "     Your current system settings:": PRINT : COLOR 2

a$ = "None": IF s%(1) > 0 THEN a$ = "CGA"
IF s%(1) > 2 THEN a$ = "Hercules/Olivetti/AT&T"
IF s%(1) > 4 THEN a$ = "EGA/VGA": IF s%(1) = 9 THEN a$ = a$ + " 640x350"
IF s%(1) > 9 THEN a$ = "EGA/VGA Monochrome"
IF s%(1) > 10 THEN a$ = "VGA/MCGA"
PRINT SPC(10); "1.  Graphics mode: " + a$ + "."

a$ = "2.  Text": IF s%(2) = 2 THEN a$ = "2.  Graphic"
PRINT SPC(10); a$; " version of the Main Hall.": PRINT SPACE$(10);
PRINT "3.  "; : COLOR s%(3): PRINT "Your Current Main Hall text color."
COLOR 2: PRINT SPC(10); "4.  System delay value ="; dly#: PRINT

COLOR 3: PRINT "     Select option to change:": PRINT
c = 10: c1 = 10: k = em0
CALL EDXMenuM(c, c1, k - 4, k, 2, 0)

IF c = 5 OR c1 = 3 THEN
  IF up = 1 THEN CALL EDX.Save.Settings
  EXIT SUB
END IF

COLOR 3, 0: IF c < 5 THEN up = 1
IF c = 1 THEN CALL EDX.Set.Screen: GOTO ControlPanel
IF c = 2 THEN s%(2) = 1 + ABS(s%(2) = 1): GOTO ControlPanel
IF c = 3 THEN
  CLS : PRINT "Choose new color for text Main Hall:": PRINT
  c = 0: c1 = 15: be = 16: en = 30
  CALL EDXMenuM(c, c1, be, en, 2, 0)
  s%(3) = c: GOTO ControlPanel
END IF
IF c = 4 THEN CALL EDX.Set.Speed: GOTO ControlPanel
END SUB

SUB EDX.Main.Menu (c)
'             Init variables
k$ = " <1> Enter the Main Hall   " + " <2> Continue a saved game "
k$ = k$ + " <3> Edit characters       " + " <4> Dungeon Designer menu "
k$ = k$ + " <5> Remove an adventure   " + " <6> View/print manuals    "
k$ = k$ + " <7> Control panel         " + " <8> Utilities menu        "
k$ = k$ + " <9> Quit Eamon Deluxe     "
REDIM m$(9): FOR x = 1 TO 9: m$(x) = MID$(k$, 27 * (x - 1) + 1, 27): NEXT
keyz$ = CHR$(72) + CHR$(75) + CHR$(80) + CHR$(77) + CHR$(13) + "123456789+=-_"
t1$ = " ... Eamon Deluxe Pioneer Versions R.I.P. (1997-2007) ...  "
t1$ = t1$ + "The Bort Software Archive humbly presents: The Abandoned World of "
t1$ = t1$ + "Eamon Deluxe 4.5. Ended in 2007 and closed forever on December "
t1$ = t1$ + "9th, 2011. At some point it was based upon the classic Eamon "
t1$ = t1$ + "Fantasy Gaming System which was created by some guy who won't talk "
t1$ = t1$ + "about it. That guy passed it on to another guy who will now only "
t1$ = t1$ + "talk about it once a year and who ended up passing it on to a third "
t1$ = t1$ + "guy who used to talk to everyone, but then quit. A fourth guy "
t1$ = t1$ + "took good care of it after that but, when nobody was talking about "
t1$ = t1$ + "it, he went back to school and started talking infrequently. Now "
t1$ = t1$ + "mostly maintained by Frank Black who will talk to anybody because "
t1$ = t1$ + "it's more fun than being weird and not talking for no reason. And "
t1$ = t1$ + "it's rumored that he's a good cook too. Go ahead, email him at "
t1$ = t1$ + "eamondeluxe@gmail.com and see for yourself. He may even talk to "
t1$ = t1$ + "you that same day! ... Eamon Deluxe Pioneer Versions R.I.P. (1997-2007) ...  "
't1$ = t1$ + " E-mail comments to: [oliver@clothes.off] "
k$ = CHR$(1) + " " + CHR$(2) + " ": k$ = RTRIM$(k$ + k$ + k$ + k$ + k$)
k$ = k$ + " - Extra smiley faces ordered for Thomas Ferguson (to be sent C.O.D.) -  " + k$
t1$ = SPACE$(10) + k$ + " " + t1$ + " " + k$
t2$ = SPACE$(40) + t1$ + SPACE$(15)
t1$ = SPACE$(30) + t1$ + SPACE$(20)

'            Make title screen
SCREEN 0: WIDTH 80: CLS : COLOR 4, 0: LOCATE 1, 21
PRINT STRING$(40, 219); : LOCATE 25, 21: PRINT STRING$(40, 219);
FOR x = 2 TO 24
   LOCATE x, 21: PRINT CHR$(219); : LOCATE x, 60: PRINT CHR$(219);
NEXT

LOCATE 5, 23: COLOR 12, 0: PRINT "The Wonderful World of Eamon Deluxe";
LOCATE 7, 34: PRINT "By Frank Black"; : v = 9: COLOR 3, 0
FOR x = 1 TO 9: LOCATE v, 27: PRINT m$(x): v = v + 1: NEXT
COLOR 12: LOCATE 20, 26: PRINT "Eamon Deluxe Environment v4.5";
COLOR 0, 4: LOCATE 1, 23: PRINT "<Press + and - to speed up and down>";
COLOR 0, 4: LOCATE 25, 23: PRINT "<Arrow Keys=Select>   <Enter=Accept>";

'        Set up animation variables
c = 1: v = 20: bs1 = 24: bs2 = 56: t1 = 1: t2 = LEN(t2$) - 8
COLOR 7, 0: cc# = CC3# - 1: a$ = CHR$(179): f = 0

'        Animate while waiting for keypress
EDX.Main.Menu:
IF c > 9 THEN c = 1
IF c < 1 THEN c = 9
COLOR 14, 1: LOCATE 8 + c, 27: PRINT m$(c); : COLOR 4, 0
DO
   cc# = cc# + 1
   IF cc# = CC1# THEN
     LOCATE v, bs1: PRINT "/"; : LOCATE v, bs2: PRINT "/"; : t3 = 1
   END IF
   IF cc# = CC2# THEN LOCATE v, bs1: PRINT a$; : LOCATE v, bs2: PRINT a$;
   IF cc# = CC3# THEN
     LOCATE v, bs1: PRINT "\"; : LOCATE v, bs2: PRINT "\"; : cc# = 0: t3 = 1
   END IF
   IF t3 = 1 THEN
     LOCATE 3, 23: COLOR 15: PRINT MID$(t1$, t1, 36);
     t1 = t1 + 1: IF t1 > LEN(t1$) THEN t1 = 1
     LOCATE 23, 23: PRINT MID$(t2$, t2, 36); : COLOR 4
     t3 = 0: t2 = t2 - 1: IF t2 < 1 THEN t2 = LEN(t1$)
   END IF
   k$ = INKEY$: k = INSTR(keyz$, RIGHT$(k$, 1))
   IF k < 5 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

' Speed up and down
IF k > 14 THEN
  IF k = 15 OR k = 16 THEN dly# = dly# - 100: IF dly# < 100 THEN dly# = 100
  IF k = 17 OR k = 18 THEN dly# = dly# + 100
  CC1# = INT(dly# / 16.6): CC2# = CC1# * 2: CC3# = CC1# * 3
  cc# = 0: k = 0: k$ = "": f = 1: GOTO EDX.Main.Menu
END IF
'      Exit
IF k = 5 THEN
  WIDTH 80: CLS : IF f = 1 THEN CALL EDX.Save.Settings
  EXIT SUB
END IF
'      Change selection
COLOR 3, 0: LOCATE 8 + c, 27: PRINT m$(c);
IF k < 3 THEN c = c - 1
IF k > 2 AND k < 5 THEN c = c + 1
IF k > 4 THEN c = k - 5
GOTO EDX.Main.Menu
END SUB

SUB EDX.Save.Settings
'  Save file SETTINGS.DAT which contains system speed & preferences
'
SaveSettings:
CLS : PRINT "Saving system settings..."
GOSUB SaveSet1: CHDIR "MAIN": GOSUB SaveSet1: CHDIR "..": CHDIR "DD"
GOSUB SaveSet1: CHDIR "..": CHDIR "UTILS"
GOSUB SaveSet1: CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #1 LEN = 90: GET #1, 1, adv: CLOSE
FOR a = 1 TO adv.NUMBER
   a$ = LTRIM$(RTRIM$(STR$(a))): ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
   CHDIR ad$: GOSUB SaveSet1: CHDIR ".."
NEXT
EXIT SUB

SaveSet1:
OPEN "SETTINGS.DAT" FOR OUTPUT AS #1
  PRINT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: WRITE #1, s%(x): NEXT
CLOSE
RETURN
END SUB

SUB EDX.Select.Adventure (c, a$)
'/// Eamon Deluxe Adventure Selection
'
'   Codes passed to SUB:
'    c=0 - Start from EAMONDX directory
'    c=1 - Back up one directory before starting
'    c=2 - Start from EDX, load designs names also
'    c=3 - Back up one, load designs
'     a$ - Name of directory to return to, if a$ = "" then no return
'          is made
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'           (0=None, -1=Design 1, -2=Design 2, -[Choice] - 2=Bad Record)
'     a$ - Name of adventure directory
'
'   Notes:
'     Requires the data type "adv" must be in the main program and
'     must be dimensioned as SHARED
'


'            Load adventure names
IF c = 1 OR c = 3 THEN CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
   GET #2, 1, adv: numadv = adv.NUMBER: numadv1 = numadv
   REDIM advn$(numadv + 2)
   FOR x = 2 TO numadv + 1
      GET #2, x, adv
      advn$(x - 1) = LEFT$(LTRIM$(RTRIM$(adv.ANAME$)), 38)
   NEXT
CLOSE

'            Load design names
IF c = 2 OR c = 3 THEN
  CHDIR "dd"
    OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE
  CHDIR ".."
  IF d1 = 1 THEN
    CHDIR "DGN-1"
      OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, x, x, x, x, k$: CLOSE
      numadv = numadv + 1: advn$(numadv) = LEFT$(k$, 26) + "  (Design 1)"
    CHDIR ".."
  END IF
  IF d2 = 1 THEN
    CHDIR "DGN-2"
      OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, x, x, x, x, k$: CLOSE
      numadv = numadv + 1: advn$(numadv) = LEFT$(k$, 26) + "  (Design 2)"
    CHDIR ".."
  END IF
END IF
'             Return to current directory
IF (c = 1 OR c = 3) AND a$ <> "" THEN CHDIR a$

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

SelectADVa:
GOSUB SelectADV0

SelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB SelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  k$ = LTRIM$(RTRIM$(STR$(c))): a$ = LEFT$("E000", 4 - LEN(k$)) + k$
  IF advn$(c) = "<Bad Record>" THEN c = -c - 2
  IF c = numadv1 + 2 OR (c = numadv1 + 1 AND d1 = 0) THEN a$ = "DGN-2": c = -2
  IF c = numadv1 + 1 THEN a$ = "DGN-1": c = -1
  IF k = 1 THEN c = 0: a$ = ""
  VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO SelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO SelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO SelectADV

'       Set up screen
SelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
SelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDX.Set.Screen
' See if graphic modes are available for CGA, EGA/VGA,
'
ProgErr = 0
ON ERROR GOTO FileIOError
s%(1) = 9
  SCREEN 9
IF ProgErr > 0 THEN s%(1) = 7: ProgErr = 0
  SCREEN 7
IF ProgErr > 0 THEN s%(1) = 1: ProgErr = 0
  SCREEN 1
IF ProgErr > 0 THEN s%(1) = 0
ON ERROR GOTO 0

SCREEN 0: WIDTH 80: CLS

IF s%(1) = 0 THEN
  PRINT
  PRINT "Sorry, but your computer doesn't seem to have a graphics adapter that I can use."
  PRINT "You won't get to see the intro graphics or visit the Graphic Main Hall."
  s%(2) = 1: CALL GetKey(1, ""): EXIT SUB
END IF

PRINT "You seem to have a color graphics adapter.  The intro to Eamon Deluxe will run"
PRINT "in three different screen modes.  The ones available to you are:": PRINT
c = 0: c1 = 0: be = 10: en = 10 + ABS(s%(1) > 1) + ABS(s%(1) > 7)
CALL EDXMenuM(c, c1, be, en, 2, 0)
s%(1) = 1 + 6 * ABS(c > 1) + 2 * ABS(c = 3)
END SUB

SUB EDX.Set.Speed
'  Set a delay value based on CPU speed
'    Sets DLY# variable to last (about) 1 second in a plain FOR/NEXT loop
'
CLS : PRINT "Setting program speed..."
dly# = 0: x = TIMER + 1
DO
  dly# = dly# + 1
LOOP UNTIL TIMER >= x
CC1# = INT(dly# / 16.6): CC2# = CC1# * 2: CC3# = CC1# * 3
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB GetKey (k, a$)
' Standard Eamon Deluxe routine to get a single keypress
'
'  Arguments passed to SUB
'      k=0 - No prompt, cursor is displayed at current location
'      k=1 - "Hit any key" prompt with twirly cursor
'      k=2 - "[More]" prompt with no cursor / "[More]" is erased and cursor
'            is restored to its original location upon exit
'       a$ - Accept only characters stored in a$ string.  If a$ = "" then
'            any keypress is acceptable
'
'  Arguments returned from SUB:
'        k - The ASC value of the key pressed.  If a$ was used to specify
'            keys then k will hold the location in a$ of the keypress instead
'            If k has a negative value then a special key was pressed (e.g.
'            function and arrow keys).  The absolute value is the key
'            pressed (either ASC value or location in a$)
'       a$ - Key pressed (Rightmost content of INKEY$)
'
GetKey:
IF k = 1 THEN PRINT : PRINT "Hit any key to continue...";
v = CSRLIN: bs = POS(0): cc# = CC3# - 1: c = 0: x$ = INKEY$
IF k = 2 THEN PRINT "[MORE]";
DO
   IF k <> 2 THEN
     cc# = cc# + 1
     IF cc# = CC1# THEN LOCATE v, bs: PRINT "/";
     IF cc# = CC2# THEN LOCATE v, bs: PRINT CHR$(179);
     IF cc# = CC3# THEN LOCATE v, bs: PRINT "\"; : cc# = 0
   END IF
   k$ = INKEY$: IF a$ <> "" AND k$ <> "" THEN c = INSTR(a$, RIGHT$(k$, 1))
   IF a$ = "" OR k = 2 THEN IF k$ <> "" THEN c = -1
LOOP UNTIL c <> 0
IF k = 2 THEN LOCATE v, bs: PRINT "      "; : LOCATE v, bs
a$ = RIGHT$(k$, 1): k = ASC(a$): IF c > 0 THEN k = c
IF LEN(k$) > 1 THEN k = -k
IF k <> 2 THEN PRINT
EXIT SUB
END SUB

SUB Header (h$)
l1$ = "      Eamon Deluxe Environment v4.0 ͻ"
l2$ = "     " + SPACE$(63) + ""
l3$ = "     " + STRING$(63, "") + ""
CLS : PRINT l1$: PRINT l2$: PRINT l2$: PRINT l2$: PRINT l3$
LOCATE CSRLIN - 3, (79 - LEN(h$)) / 2: PRINT h$: LOCATE CSRLIN + 2
PRINT : VIEW PRINT 7 TO 25
END SUB

SUB Remove.Adventure
'  Remove an installed Eamon Deluxe adventure --
'     First try to delete all files in adventure directory, if not possible
'     then it gets marked as "Bad" in the "ADVENTRS" file and is ignored
'     until it can be properly removed.
'
AdvRemove:
ad = 2: CALL EDX.Select.Adventure(ad, ad$)
IF ad = 0 THEN EXIT SUB
IF ad < -2 THEN ad = ABS(ad) - 2

IF ad < 0 AND ad > -3 THEN
  PRINT "You must use the dungeon designer menu to remove."
  CALL GetKey(1, ""): EXIT SUB
END IF

COLOR 14: PRINT "!! WARNING !!": PRINT : COLOR 2
PRINT "This will destroy all data in the adventure directory!  Make sure you have a"
PRINT "backup copy of this adventure or it will be gone forever.": PRINT

ProgErr = 0
ON ERROR GOTO FileIOError
k$ = "": CHDIR ad$: IF ProgErr > 0 THEN END
OPEN "name.dat" FOR INPUT AS #1
    IF ProgErr = 0 THEN INPUT #1, x, x, x, x, k$: CHDIR ".."
CLOSE

IF k$ <> "" THEN PRINT "Delete: "; k$; "?"
PRINT : PRINT "Enter "; CHR$(34); "Y"; CHR$(34); " or "; CHR$(34); "N";
PRINT CHR$(34); " to continue..."; : k = 0: a$ = CHR$(27) + "NnYy"
CALL GetKey(k, a$): IF k < 4 THEN EXIT SUB
PRINT "Really, really sure?"; : k = 0: a$ = CHR$(27) + "NnYy"
CALL GetKey(k, a$): IF k < 4 THEN EXIT SUB

ProgErr = 0
CHDIR ad$: KILL "*.*": CHDIR "..": RMDIR ad$

ON ERROR GOTO 0
IF ProgErr = 75 THEN
  COLOR 14: PRINT "Error removing files/directory.  Use a DOS or Windows utility to delete"
  PRINT "All files from the directory \EAMONDX\"; ad$: PRINT
  PRINT "Do not remove the directory itself, but all files and subdirectories within it."
  PRINT "When done select the Remove option again.  Until then it will be marked as"
  PRINT "a bad record in adventure file."
  COLOR 2: CALL GetKey(1, "")
  OPEN "ADVENTRS" FOR RANDOM AS #1 LEN = 90
      adv.ANAME = "<Bad Record>": PUT #1, ad + 1, adv
  CLOSE
  EXIT SUB
END IF

OPEN "ADVENTRS" FOR RANDOM AS #1 LEN = 90
GET #1, 1, adv: na = adv.NUMBER
na = na - 1: adv.NUMBER = na: PUT #1, 1, adv
IF ad = na + 1 THEN EXIT SUB

GET #1, na + 2, adv: PUT #1, ad + 1, adv
a$ = LTRIM$(RTRIM$(STR$(na + 1))): a$ = LEFT$("E000", 4 - LEN(a$)) + a$
NAME a$ AS ad$
CLS : PRINT "Adventure removed.": CALL GetKey(1, "")
END SUB

SUB View.Manuals
COLOR 3: h$ = "View/print documentation"
CALL Header(h$)

PRINT "  Select file to view/print:": PRINT
c = 0: c1 = 10
CALL EDXMenuM(c, c1, 1, 4, 3, 0)
IF c = 4 OR c1 = 3 THEN EXIT SUB

CLS : f = c: c = 0: c1 = 10
CALL EDXMenuM(c, c1, 5, 6, 3, 0)
IF c1 = 3 THEN EXIT SUB

VIEW PRINT 1 TO 25: CLS : COLOR 7, 0: LOCATE 10, 5
IF c = 1 THEN
  PRINT "Hit <ESC> to exit at any time"
  FOR cc# = 1 TO dly# * 6: NEXT
END IF

CLS :  L = 0: p = ABS(c = 2)
f$ = em$(f + 6): OPEN "manuals\" + f$ FOR INPUT AS #1

ProgErr = 0
ON ERROR GOTO FileIOError

ViewMan:
LINE INPUT #1, a$

IF ProgErr > 0 THEN
  ON ERROR GOTO 0
  IF ProgErr <> 62 THEN BEEP: PRINT "Error reading file ("; ProgErr; ")"
  IF ProgErr = 68 THEN PRINT "  (Printer not connected)"
  CLOSE : CALL GetKey(1, ""): EXIT SUB
END IF

IF p = 1 THEN LPRINT a$
IF p = 0 THEN
  PRINT a$: L = L + 1
  IF L > 21 THEN
    k = 2: a$ = "": CALL GetKey(k, a$): CLS : L = 0
    IF k = 27 THEN CLOSE : EXIT SUB
  END IF
END IF
GOTO ViewMan
END SUB

